#ifndef MAPLIST_H
#define MAPLIST_H

#include<qdir.h>
#include<qstringlist.h>
#include<qtextstream.h>
#include<qfile.h>
#include<map>
#include"radian.h"

#include<stdio.h>

class MapList {
public:
	MapList(const QString &path = "./maps");
	QString searchMapFileName(long ns, long ew);
	QString pointMapFileName(int diffLat, int diffLong);
	void createMapList();
	void changeMap(const QString &path);

private:
	void updateItudeList(const QString &path, map<long, int> *longitude,
			map<long, int> *latitude, unsigned int * maxFileLen);
	void updateMapList(const QString &path, QFile *mapListFile);

	QString _basePath;
	QFile _mapListFile;
	map<long, int> _latitude;
	map<long, int> _longitude;
	int _latid, _longid;
	unsigned int _maxFileLen;
	unsigned long _baseLength;

	//const long _index_size = sizeof(Q_UINT32) + sizeof(long) * 2;
	//Q_UINT32 _magicNumber = 0x15614878;
};

#endif //MAPLIST_H
